<?php
/*************************
  Coppermine Photo Gallery
  ************************
  Copyright (c) 2003-2005 Coppermine Dev Team
  v1.1 originaly written by Gregory DEMAR

  This program is free software; you can redistribute it and/or modify
  it under the terms of the GNU General Public License as published by
  the Free Software Foundation; either version 2 of the License, or
  (at your option) any later version.
  ********************************************
  Coppermine version: 1.4.8
  $Source: /cvsroot/cpg-contrib/master_template/codebase.php,v $
  $Revision: 1.3 $
  $Author: donnoman $
  $Date: 2005/12/08 05:46:49 $
**********************************************/
/*************************
fotofreek's mod addapted by Frantz for Coppermine photo_summary plugin
**************************/
if (!defined('IN_COPPERMINE')) die('Not in Coppermine...');
require('include/init.inc.php');
require ('plugins/stats/include/init.inc.php');
function makezeros(&$stats){

	if (empty($stats['comments'])) $stats['comments'] = 0;
	if (empty($stats['pictures'])) $stats['pictures'] = 0;
	if (empty($stats['users'])) $stats['users'] = 0;
}

function getbars($data){

	$max = array('comments' => 0, 'users' => 0, 'pictures' => 0);
	
	foreach ($data as $period => $stats){
		foreach($stats as $param => $value){
			$max[$param] = max($max[$param], $value);
		}
	}
	
	$bars = array();
	
	foreach ($data as $period => $stats){
		foreach($stats as $param => $value){
			$bars[$period][$param] = floor(($value / $max[$param]) * 100);
			if ($value) $bars[$period][$param] = max($bars[$period][$param], 1);
		}
	}
	
	return $bars;
}

pageheader($lang_plugin_stats['name']);

starttable('100%',$lang_plugin_stats['name'],4);

?>

<tr>
	<td class="tableh1"><?php echo $lang_plugin_stats['date'];?></td>
	<td class="tableh1"><?php echo $lang_plugin_stats['comments'];?></td>
	<td class="tableh1"><?php echo $lang_plugin_stats['pictures'];?></td>
	<td class="tableh1"><?php echo $lang_plugin_stats['members'];?></td>
</tr>

<?php

$years = array();

$sql = "SELECT YEAR(msg_date) AS period, COUNT(*) AS number 
FROM {$CONFIG['TABLE_COMMENTS']} 
GROUP BY period
ORDER BY period DESC";

$result = cpg_db_query($sql);
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['comments'] = $row['number'];
mysql_free_result($result);

$sql = "SELECT YEAR(FROM_UNIXTIME(ctime)) AS period, COUNT(*) AS number 
FROM {$CONFIG['TABLE_PICTURES']} 
GROUP BY period 
ORDER BY period DESC";

$result = cpg_db_query($sql);
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['pictures'] = $row['number'];
mysql_free_result($result);

$sql = "SELECT YEAR(FROM_UNIXTIME({$cpg_udb->field['regdate']})) AS period, COUNT(*) AS number 
FROM {$cpg_udb->usertable}
GROUP BY period
ORDER BY period DESC";

$result = cpg_db_query($sql);		
while ($row = mysql_fetch_assoc($result)) $years[$row['period']]['users'] = $row['number'];
mysql_free_result($result);

krsort($years);

$ybars = getbars($years);

foreach ($years as $year => $stats){
		
	makezeros($stats);
	makezeros($ybars[$year]);

	if (isset($_GET['year']) && $_GET['year'] == $year){
		$type = 'collapse';
		$y = '';
	} else {
		$type = 'expand';
		$y = "&amp;year=$year";
	}
	
	echo <<< EOT

<tr>
	<td class="tableb"><a href="index.php?file=stats/stats$y"><img src="plugins/stats/images/$type.gif" border="0">&nbsp;$year</a></td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$ybars[$year]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$ybars[$year]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$ybars[$year]['users']}">&nbsp;{$stats['users']}</td>
</tr>

EOT;

	if (isset($_GET['year']) && $_GET['year'] == $year){
		
		$months = array();
	
		$sql = "SELECT MONTH(msg_date) AS period, COUNT(*) AS number 
		FROM {$CONFIG['TABLE_COMMENTS']} 
		WHERE YEAR(msg_date) = $year 
		GROUP BY period
		ORDER BY period DESC";
		
		$result = cpg_db_query($sql);
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['comments'] = $row['number'];
		mysql_free_result($result);
		
		$sql = "SELECT MONTH(FROM_UNIXTIME(ctime)) AS period, COUNT(*) AS number 
		FROM  {$CONFIG['TABLE_PICTURES']} 
		WHERE YEAR(FROM_UNIXTIME(ctime)) = $year
		GROUP BY period
		ORDER BY period DESC";
		
		$result = cpg_db_query($sql);
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['pictures'] = $row['number'];
		mysql_free_result($result);

		$sql = "SELECT MONTH(FROM_UNIXTIME({$cpg_udb->field['regdate']})) AS period, COUNT(*) AS number 
		FROM {$cpg_udb->usertable}
		WHERE YEAR(FROM_UNIXTIME({$cpg_udb->field['regdate']})) = $year
		GROUP BY period
		ORDER BY period DESC";
		
		$result = cpg_db_query($sql);		
		while ($row = mysql_fetch_assoc($result)) $months[$row['period']]['users'] = $row['number'];
		mysql_free_result($result);
					
		krsort($months);
		
		$mbars = getbars($months);

		foreach ($months as $month => $stats){

			makezeros($stats);
			makezeros($mbars[$month]);

			$monthname = date('F', strtotime("$month/01/$year"));
			$mname=$lang_plugin_stats_month[$monthname];
			if (isset($_GET['month']) && $_GET['month'] == $month){
				$type = 'collapse';
				$m = '';
			} else {
				$type = 'expand';
				$m = "&amp;month=$month";
			}
			
			echo <<< EOT

<tr>
	<td class="tableb">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;<a href="index.php?file=stats/stats&year=$year$m"><img src="plugins/stats/images/$type.gif" border="0">&nbsp;$mname</a></td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$mbars[$month]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$mbars[$month]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$mbars[$month]['users']}">&nbsp;{$stats['users']}</td>
</tr>

EOT;

			if (isset($_GET['month']) && $_GET['month'] == $month){
			
				$days = array();
				
				$sql = "SELECT DAY(msg_date) AS period, COUNT(*) AS number 
				FROM {$CONFIG['TABLE_COMMENTS']} 
				WHERE YEAR(msg_date) = $year 
				AND MONTH(msg_date) = $month
				GROUP BY period 
				ORDER BY period DESC";
				
				$result = cpg_db_query($sql);
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['comments'] = $row['number'];
				mysql_free_result($result);
				
				$sql = "SELECT DAY(FROM_UNIXTIME(ctime)) AS period, COUNT(*) AS number 
				FROM  {$CONFIG['TABLE_PICTURES']} 
				WHERE YEAR(FROM_UNIXTIME(ctime)) = $year
				AND MONTH(FROM_UNIXTIME(ctime)) = $month
				GROUP BY period 
				ORDER BY period DESC";
				
				$result = cpg_db_query($sql);
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['pictures'] = $row['number'];
				mysql_free_result($result);
				
				$sql = "SELECT DAY(FROM_UNIXTIME({$cpg_udb->field['regdate']})) AS period, COUNT(*) AS number 
				FROM {$cpg_udb->usertable}
				WHERE YEAR(FROM_UNIXTIME({$cpg_udb->field['regdate']})) = $year
				AND MONTH(FROM_UNIXTIME({$cpg_udb->field['regdate']})) = $month
				GROUP BY period
				ORDER BY period DESC";
				
				$result = cpg_db_query($sql);		
				while ($row = mysql_fetch_assoc($result)) $days[$row['period']]['users'] = $row['number'];
				mysql_free_result($result);
				
				krsort($days);
				
				$dbars = getbars($days);
				
				foreach ($days as $day => $stats){

					$dayname = date($lang_plugin_stats_date, strtotime("$month/$day/$year"));
				
					makezeros($stats);
					makezeros($dbars[$day]);
					
					echo <<< EOT

<tr>
	<td class="tableb">&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;&nbsp;$dayname</td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$dbars[$day]['comments']}">&nbsp;{$stats['comments']}</td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$dbars[$day]['pictures']}">&nbsp;{$stats['pictures']}</td>
	<td class="tableb"><img src="plugins/stats/images/bar.gif" height="8" width="{$dbars[$day]['users']}">&nbsp;{$stats['users']}</td>
</tr>

EOT;
				}
			}
		}
	}
}

endtable();

pagefooter();

ob_end_flush();
?>